--- old/usr/src/uts/i86pc/os/ddi_impl.c	2014-10-23 10:42:17.974635652 -0400
+++ new/usr/src/uts/i86pc/os/ddi_impl.c	2014-10-23 10:42:17.979572466 -0400
@@ -1536,7 +1536,7 @@
 	 * the attributes leads to a failure.
 	 */
 	uint_t cache_attr = IOMEM_CACHE_ATTR(flags);
-	if ((cache_attr != 0) && ((cache_attr & (cache_attr - 1)) != 0))
+	if ((cache_attr != 0) && !ISP2(cache_attr))
 		return (B_FALSE);
 
 	/* All cache attributes are supported on X86/X64 */
@@ -1627,9 +1627,8 @@
 	}
 
 	if (attr->dma_attr_minxfer == 0 || attr->dma_attr_align == 0 ||
-	    (attr->dma_attr_align & (attr->dma_attr_align - 1)) ||
-	    (attr->dma_attr_minxfer & (attr->dma_attr_minxfer - 1))) {
-			return (DDI_FAILURE);
+	    !ISP2(attr->dma_attr_align) || !ISP2(attr->dma_attr_minxfer)) {
+		return (DDI_FAILURE);
 	}
 
 	/*
